<template>
  <div class="row">
    <b-col md="3" class="pr-3">
      <div class="nav-scenario-config">
        <div class="mb-2">
          <div class="nav-scenario-config-form">
            <ExploreSearchBox
              :first="firstParameterIndex"
              :last="filteredParameterCount"
              :total="totalParameterCount"
              placeholder="Search in parameters..."
              item-type="parameters"
              @search="setSearchValue"
            />
          </div>
        </div>
        <div class="d-none d-sm-inline-block d-lg-block">
          <div class="mb-3">
            <ParametersPanel :parameters="filteredParameterTree" />
          </div>
        </div>
      </div>
    </b-col>
    <div class="col-sm-12 col-md-9">
      <ParametersCardDeck v-if="!loading" :parameters="parameters" />
      <Loading v-else></Loading>
    </div>
  </div>
</template>

<script>
import { mapGetters } from 'vuex';
import searchFilterMixin from '~/mixins/search-filter.js';
export default {
  mixins: [searchFilterMixin],
  props: {
    loading: {
      type: Boolean,
      default: false,
    },
  },
  data() {
    return {
      valueToSearch: '',
    };
  },
  head() {
    return {
      title: 'Projects - RISIS Workspace',
    };
  },
  computed: {
    ...mapGetters({
      parameters: 'parameters/parameters',
      inputMap: 'parameters/inputMap',
    }),
    filteredParameters() {
      return this.applyFilterParameter(this.parameters, this.valueToSearch);
    },
    filteredParameterTree() {
      return this.filteredParameters.matches;
    },
    filteredParameterCount() {
      return this.filteredParameters.count;
    },
    firstParameterIndex() {
      return this.filteredParameterCount > 0 ? 1 : 0;
    },
    totalParameterCount() {
      return Object.keys(this.inputMap).length;
    },
  },
  methods: {
    setSearchValue(valueToSearch) {
      this.valueToSearch = valueToSearch;
    },
  },
};
</script>
